<?php

namespace Drupal\drupal_sheetjs\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\drupal_sheetjs\Services\DrupalSheetjsConfigService;

/**
 * Controller for Drupal SheetJS functionality.
 */
class DrupalSheetjsController extends ControllerBase {

  /**
   * Retrieves the test page.
   *
   * @return array
   *   The renderable array for the test page.
   */
  public function test() {
    $drupal_sheetjs_config = $this->_getDrupalSheetjsConfigDataService()->getData();
    unset($drupal_sheetjs_config['data']['full_data']);
    return [
      '#theme' => 'test',
      '#drupal_sheetjs_config' => $drupal_sheetjs_config,
    ];
  }

  /**
   * Retrieves the custom test page.
   *
   * @return array
   *   The renderable array for the custom test page.
   */
  public function test_custom() {
    $drupal_sheetjs_config = $this->_getDrupalSheetjsConfigDataService()->getData('is_test');
    unset($drupal_sheetjs_config['data']['full_data']);
    return [
      '#theme' => 'test_custom',
      '#drupal_sheetjs_config' => $drupal_sheetjs_config,
    ];
  }

  /**
   * Retrieves the Drupal SheetJS configuration service.
   *
   * @return \Drupal\drupal_sheetjs\Services\DrupalSheetjsConfigService
   *   The Drupal SheetJS configuration service.
   */
  private function _getDrupalSheetjsConfigDataService() {
    return new DrupalSheetjsConfigService();
  }

}
